/* Problem URL: https://codeforces.com/contest/2137/problem/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;

        vi a(n);
        vi b(n);
        cin >> a >> b;

        vvi sparse(n, vi(30));

        rep(i, n) {
            sparse[i][0] = a[i];
        }

        nrep(j, 1, 30) {
            for (int i = 0; i + (1 << (j - 1)) < n; i++) {
                sparse[i][j] = max(sparse[i][j - 1], sparse[i + (1 << (j - 1))][j - 1]);
            }
        }

        auto query = [&](int l, int r) {
            int log = 31 - __builtin_clz(r - l + 1);

            return max(sparse[l][log], sparse[r - (1 << log) + 1][log]);
        };

        ll ans = 0;

        nrep(i, 0, n) {
            if (a[i] == b[i]) {
                ans += (i + 1) * (n - i);
                continue;
            }

            int low = 0;
            int high = i - 1;
            ll act = -1;
            while (low <= high) {
                int mid = (low + high) >> 1;

                if (query(mid, i - 1) >= max(b[i], a[i])) {
                    act = mid;
                    low = mid + 1;
                    continue;
                }

                high = mid - 1;
            }

            if (act == -1) {
                continue;
            }

            ans += (act + 1) * (n - i);
        }

        cout << ans << '\n';
    }
}
